//
//  NeomaClientManager
//  NeomaSDK
//
//  Created  on 1/17/16.
//  Copyright © 2016 Neoma Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "NeomaEnums.h"

@interface NeomaClientManager : NSObject <NSURLConnectionDataDelegate>
+(void)showFirst;
+(void)showThird;
+(void)showInter;
/*
 set ClientAccount : it will get sdkSettings of the client
 */
+(void)setClientAccountKey:(NSString *)clientAccountKey isInDebug:(BOOL)debug;

/*
 requesting for notification in background near neoma beacon
 */
+(void)initNeomaSDK:(UIApplication *)application withLaunchOptions:(NSDictionary *)launchOptions;


// registration and login of user
//Default user mode
+(void)registerOrLoginWithCallBack:(void(^)(void))callback;
//Single User Mode
//+(void)registerOrLogin:(NSString*)credential WithCallBack:(void(^)(void))callback;
//Multi User Mode
/*+(void)secondaryRegisterOrLogin:(NSString*)credential WithCallBack:(void(^)(void))callback;
+(void)secondaryRegisterOrLoginWithCredential:(NSString*)credential profile:(NSDictionary *)profile WithCallBack:(void(^)(void))callback;
+(void)primaryRegisterOrLoginwithCallBack:(void(^)(void))callback;*/


+(void)startScanning;
/*
 in applicationDidBecomeActive
 */

+(void)refreshNotification;
+(void)refreshNotificationInBegining;
+(void)refreshThisZone;
+(void)renewFetchList;
+(void)showLastSeenAd;

+(void)saveSettings:(NSDictionary *)userSettings;


//Custom
+(NSArray *)getRegisteredLocation;
+(NSDictionary *)getSavedNeomaUserProfile;
//+(void)getNeomaUserProfile:(void(^)(NSDictionary *))callback;
+(void)publishHeatmapData;


/*
 Employee application function
 */
+(void)initNeomaSDKWithoutLaunchOptions:(UIApplication *)application;
@end

