//
//  NeomaController.h
//  NeomaSDK
//
//  Created by Antima Gangwar on 15/10/19.
//  Copyright © 2019 Neoma Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface NeomaController : NSObject
/*!
    @brief Backgound notification handler

    @discussion Handles all types of notification coming from neoma server. Updates resources when update on server available.

    @param application The input value representing current visible window.
    @param userInfo The input value representing current visible window.
    @param completionHandler The input value representing current visible window.
*/
+(void)handleNotificationOfApplication:(UIApplication*)application withInfo:(NSDictionary *)userInfo fetchCompletionHandler:(nullable void (^)( UIBackgroundFetchResult))completionHandler;

/*!
 @brief Logout  account with credential and login anonymously

 @discussion Logs out specific credential from server

 @remark // TODO: PRIMARY LOGIN

*/
+(void)logoutOfSecondaryAccount;
+(void)getUserInfo:(NSString*)region;

/*!
  @brief Logout device account

  @discussion Logs out from server and stop all scanning services
  */
+(void)logOutDeviceAndStopScanning;

+(void)startScanning;

+(void)updateNeomaState:(UIApplication *)application;
+(void)refreshNotification;
+(void)refreshNotificationInBegining;
+(void)refreshThisZone;
+(void)renewFetchList;
+(void)showLastSeenAd;

+(void)logOutClientAndStopScanning;
+(void)logOutHotelAndStopScanning;
+(void)logOutEmpAndStopScanning;
+(void)logoutFromCurrentAccount;
@end

NS_ASSUME_NONNULL_END
