//
//  NeomaEmpManager.h
//  NeomaSDK
//
//  Created by Antima on 12/20/17.
//  Copyright © 2017 Neoma Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

@interface NeomaEmpManager : NSObject <NSURLConnectionDataDelegate>

/*
 set ClientAccount : it will get sdkSettings of the client
 */
+(void)setClientAccountKey:(NSString *)clientAccountKey isInDebug:(BOOL)debug;

/*
 show bluetooth warning if blutooth is off
 */

+(void)initNeomaSDK:(UIApplication *)application withLaunchOptions:(NSDictionary *)launchOptions;


// registration and login of user
//Default user mode
+(void)registerOrLoginWithCallBack:(void(^)(void))callback;
//Single User Mode

+(void)startScanning;
/*
 in applicationDidBecomeActive
 */

+(void)refreshNotification;
+(void)refreshNotificationInBegining;
+(void)refreshThisZone;
+(void)renewFetchList;
+(void)showLastSeenAd;

//Custom
+(void)publishHeatmapData;
+(void)test;
/*
 Employee application function
 */
+(void)initNeomaSDKWithoutLaunchOptions:(UIApplication *)application;
+(void)getDetailsFromCurrentZone:(NSString*)region completionHandler:(void(^)(BOOL))completionHandler;
+(void)getFilteredDetailsFromCurrentZone:(NSString*)region completionHandler:(void(^)(BOOL))completionHandler;
+(NSString *)getBeaconImage:(NSString *)key;

+(void)addBeaconHeatMapEntry:(NSString *)region for:(int)duration;
+(NSString *)getCurrentUserKey;
+(void)setCurrentUserKey:(NSString *)userKey;

+(void)startSession;
+(void)cancelSession;
+(void)endSession:(NSMutableDictionary *)profile userNames:(NSArray *)userNames  completionHandler:(void(^)(void))completionHandler;
+(void)reloadSession;

//push controller
+(void)createAdvertEvent:(NSString *)adKey for:(NSString *)ownerKey from:(NSString *)region;

+(void)addUserLogin:(NSArray *)userNames  profile:(NSDictionary *)dictionary completionHandler:(void(^)(NSDictionary *))completionHandler;

+(void)saveProfile:(NSMutableDictionary *)profile completionHandler:(void(^)(void))completionHandler;

+(void)updateUserLogin:(NSArray *)userNames completionHandler:(void(^)(NSDictionary *))completionHandler;

+(NSArray *)getAdvertsForBeacon:(NSString *)region;
@end
