//
//  NeomaHotelManager.h
//  NeomaSDK
//
//  Created by Antima Gangwar on 18/05/18.
//  Copyright © 2018 Neoma Ltd. All rights reserved.
//
 
#import <Foundation/Foundation.h>
#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "NeomaEnums.h"
#import "MovingBeacon.h"

@interface NeomaHotelManager : NSObject <NSURLConnectionDataDelegate>

/*
 set ClientAccount : it will get sdkSettings of the client
 */
+(void)setClientAccountKey:(NSString *)clientAccountKey isInDebug:(BOOL)debug;

/*
 requesting for notification in background near neoma beacon
 */
+(void)initNeomaSDK:(UIApplication *)application withLaunchOptions:(NSDictionary *)launchOptions;


// registration and login of user
//Default user mode
+(void)registerOrLoginWithCallBack:(void(^)(void))callback;

+(void)startScanning;
/*
 in applicationDidBecomeActive
 */

+(void)refreshNotification;
+(void)refreshNotificationInBegining;
+(void)refreshThisZone;
+(void)renewFetchList;
+(void)showLastSeenAd;

+(void)saveSettings:(NSDictionary *)userSettings;

//Custom
+(NSArray *)getRegisteredLocation;
+(NSDictionary *)getSavedNeomaUserProfile;
//+(void)getNeomaUserProfile:(void(^)(NSDictionary *))callback;
+(void)publishHeatmapData;


/*
 Employee application function
 */
+(void)initNeomaSDKWithoutLaunchOptions:(UIApplication *)application;
+(void)addQRCodeInRfid:(NSDictionary*)qrDict;
+(void)foundRFIDCard:(NSString *)rfidcard distance:(double)distance  where:(NSString *)where what:(CARDTYPE)cardType;
+(MovingBeacon *)getCardInformation:(NSString *)cardI;
+ (void)refeshInsights;
+ (void)updateCardProfile:(NSDictionary *)profile fpr:(NSString *)rfid;
+(void)update:(NSString *)readerId staff:(NSString *)staff  guest:(NSString *)guest;
+(void)updateArea:(NSString *)key cards:(NSArray *)cards  checkinTime:(NSString *)checkinTime  checkoutTime:(NSString *)checkoutTime;
+(void)addRecommendation:(NSString *)type title:(NSString *)title message:(NSString *)message  note:(NSString *)note  language:(NSString *)language timestamp:(NSString*)timestamp;
+(NSArray *)getAllReasders;
@end

