//
//  NeomaManager.h
//  NeomaSDK
//
//  Created  on 1/17/16.
//  Copyright © 2016 Neoma Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "NeomaEnums.h"

@interface NeomaManager : NSObject <NSURLConnectionDataDelegate>

/*
 Set window to let neomasdk open notification view controller
 */
+(void)setWindow:(UIWindow *)win;
/*
 set ClientAccount : it will get sdkSettings of the client
 */
+(void)setClientAccountKey:(NSString *)clientAccountKey isInDebug:(BOOL)debug;
/*
 set Apigateway key to use new API gateway.
 */
+(void)setApiGatewayKey:(NSString *)apiKey;
/*
 update deviceToken on neoma server
 */
+(void)initDeviceToken:(NSData*)deviceToken;
/*
 show bluetooth warning if blutooth is off
 */
+(void)setBluetoothWarning:(BOOL)on;

/*
 requesting for notification in background near neoma beacon
 */
+(void)initNeomaSDK:(UIApplication *)application withLaunchOptions:(NSDictionary *)launchOptions;
+(void)initNeomaSDKWithoutLaunchOptions:(UIApplication *)application;





// registration and login of user
//Default user mode
+(void)registerOrLoginWithCallBack:(void(^)(void))callback;
//Single User Mode
+(void)registerOrLogin:(NSString*)credential WithCallBack:(void(^)(void))callback;
//Multi User Mode
+(void)secondaryRegisterOrLogin:(NSString*)credential WithCallBack:(void(^)(void))callback;
+(void)secondaryRegisterOrLoginWithCredential:(NSString*)credential profile:(NSDictionary *)profile WithCallBack:(void(^)(void))callback;
+(void)primaryRegisterOrLoginwithCallBack:(void(^)(void))callback;
+(void)uniqueDeviceRegisterOrLoginWithCredential:(NSString*)credential profile:(NSDictionary *)profile WithCallBack:(void(^)(NSString *))callback;
+(void)credentialRegisterOrLoginWithCredential:(NSString*)credential profile:(NSDictionary *)profile WithCallBack:(void(^)(NSString *))callback;

+(void)startScanning;
/*
 in applicationDidBecomeActive
 */
+(void)setCurrentLocationLatitude:(double)latitude longitude:(double)longitude;

//+(void)stopTrackingAllActions;
+(void)startTrackAction:(NSString *)action withDuration:(BOOL)motitorDuration ofclass:(Class)class;
+(void)stopTrackingLastAction;
+(void)stopTrackingAction:(NSString *)action;
+(void)updateTrackingAction:(NSString *)action;
+(void)updateTrackingLastAction;
+(void)saveSettings:(NSDictionary *)userSettings;

//TEST
+(void)openNotificationListViewController;
//TEST
+(void)openFromHistoryEvent:(NSDictionary *) object language:(NSString*) language;

//Custom
//+(NSArray *)getPreferences;
//+(NSArray *)getRegisteredLocation;
+(void)publishHeatmapData;
//+(void)openLuckyDrawPage;

+(void)uploadEventData;
/*
 Employee application function
 */
+(void)update:(void (^)(UIBackgroundFetchResult))completionHandler;
//+(void)updateWithTask:(BGProcessingTask *)task;
@end
