//
//  AppDelegate.m
//  iosAWSExample
//
//  Created by Antima on 8/17/17.
//  Copyright © 2017 Antima. All rights reserved.
//

#import "AppDelegate.h"
#import <GaiaSDK/GaiaSDK.h>
#import <BackgroundTasks/BackgroundTasks.h>
#import "MapViewController.h"

@interface AppDelegate ()

@end

@implementation AppDelegate
NSString *UpdateTaskId =@"hk.neoma.sdk.update";

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    NSLog(@"didFinishLaunchingWithOptions");

    [NeomaManager setWindow:self.window];
    [NeomaManager setApiGatewayKey:@"xxxxxxxxxxxxxxxxxx"];
    #ifdef DEBUG
        [NeomaManager setClientAccountKey:@"xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" isInDebug:true];
    #endif
    #ifndef DEBUG
        [NeomaManager setClientAccountKey:@"xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" isInDebug:false];
    #endif
    //            [NeomaClientManager setClientAccountKey:[UserProfile getFromPreds:pClientAccountKey stringDefault:@""] isInDebug:true];

    [NeomaManager initNeomaSDK:application withLaunchOptions:launchOptions];
    
    
    if (@available(iOS 13.0, *)) {
           [[BGTaskScheduler sharedScheduler] registerForTaskWithIdentifier:UpdateTaskId
                                                                          usingQueue:nil
                                                                       launchHandler:^(BGProcessingTask *task) {
               [self hadleUpdate:task];
           }];
           
       } else {
           // Fallback on earlier versions
           [application setMinimumBackgroundFetchInterval:3600];
       }

    return YES;
}

- (void)application:(UIApplication*)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData*)deviceToken
{
    [NeomaManager initDeviceToken:deviceToken];
}

-(void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo fetchCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler{
    NSLog(@"XXXXXXXXX");
    
    [NeomaController handleNotificationOfApplication:application withInfo:userInfo fetchCompletionHandler:completionHandler];

}
- (void)application:(UIApplication *)application didReceiveLocalNotification:(UILocalNotification *)notification{
    NSLog(@"------ %@", notification.userInfo);
    [NeomaController handleNotificationOfApplication:application withInfo:notification.userInfo  fetchCompletionHandler:nil];
}
- (void)application:(UIApplication *)application didReceiveRemoteNotification:(NSDictionary *)userInfo
{    //if(![UserProfile getFromPreds:pClient_LoggedIn boolDefault:false]){

    
    //NSLog(@"Received notification");
    [NeomaController handleNotificationOfApplication:application withInfo:userInfo fetchCompletionHandler:nil];///}
}
//publish heat map data before app goes in background and free eventHandler for background notification
- (void)applicationDidEnterBackground:(UIApplication *)application {
    [NeomaManager publishHeatmapData];
    [NeomaCustomManager freeBeaconEventHandler];
}

//publish heat map data before terminating the app
- (void)applicationWillTerminate:(UIApplication *)application {
    [NeomaManager publishHeatmapData];
    [NeomaCustomManager freeBeaconEventHandler];

//    [self scheduleFetchRequest];

}

//deep linking override
- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url {
    NSURLComponents *urlComponents = [NSURLComponents componentsWithURL:url
                                                resolvingAgainstBaseURL:NO];
    NSLog(@"urlComponents %@", urlComponents);
    
    NSArray *queryItems = urlComponents.queryItems;
    NSLog(@"queryItems %@", queryItems);
    NSLog(@"queryItems %@", urlComponents.scheme);
    NSLog(@"queryItems %@", urlComponents.host);
    if([urlComponents.scheme isEqualToString:@"nomasdk"]){
        if([urlComponents.host isEqualToString:@"deep"]){
            

            UIStoryboard *storyboard = [UIStoryboard storyboardWithName:@"Main" bundle:nil];
            MapViewController *mapViewController =  (MapViewController*)[storyboard instantiateViewControllerWithIdentifier:@"MapViewController"];
            
            
            [mapViewController setModalPresentationStyle:UIModalPresentationFullScreen];

            [self.window.rootViewController presentViewController:mapViewController animated:YES completion:nil];;
        }

    }
    return true;// [NeomaCustomManager handleOpenURL:url];
}


-(void)hadleUpdate:(BGProcessingTask *)task API_AVAILABLE(ios(13.0)){
   //  if(q==nil)
  //  q = [[NSOperationQueue alloc] init];
    void (^completionHandler)(UIBackgroundFetchResult) =

               ^(UIBackgroundFetchResult secondValue) {
                   
                   //
               };

    [NeomaManager update:completionHandler];
    
}
-(void)application:(UIApplication *)application performFetchWithCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler
{
    [NeomaManager update:completionHandler];
        //Tell the system that you ar done.
//        completionHandler(UIBackgroundFetchResultNewData);
}
-(void)scheduleFetchRequest {
    if (@available(iOS 13.0, *)) {

        BGProcessingTaskRequest *request = [[BGProcessingTaskRequest alloc] initWithIdentifier:UpdateTaskId];
        request.requiresNetworkConnectivity = YES;
        request.earliestBeginDate = [NSDate dateWithTimeIntervalSinceNow:60*60];
        NSError *error = NULL;
        BOOL success = [[BGTaskScheduler sharedScheduler] submitTaskRequest:request error:&error];
        if (!success) {
            NSLog(@"Failed to submit request: %@",error);
        }
    }
}
@end
